@echo off
setlocal
set D2TITLE=Anything to D2 AVI encoder v1.2
title %D2TITLE%
echo %D2TITLE%

set HEIGHT=192
set BITRATE=400
set QUANT=3
set SHRINK=334
set AUDIO=mp3lame -lameopts preset=standard
set LOGFILE=divx2pass.log

:parseparams
if '%1'=='' goto endsub
if exist %1 goto paramsdone

if "%1"=="-1" set ONEPASS=1
if "%1"=="-4" set HEIGHT=240
if "%1"=="-2" set HEIGHT=160
if "%1"=="-2." set HEIGHT=176
if "%1"=="-15" set HEIGHT=208
if "%1"=="-16" set HEIGHT=193
if /i "%1" equ "-ac" set AUDIO=copy
if /i "%1" equ "-aqq" set AUDIO=mp3lame -lameopts preset=extreme
if /i "%1" equ "-aq" set AUDIO=mp3lame -lameopts preset=standard
if /i "%1" equ "-mp3" set AUDIO=mp3lame -lameopts preset=128
if /i "%1" equ "-t" set TEST=-ss 8:00 -endpos 55
if /i "%1" equ "-tt" set NOENCODE=1
if /i "%1" equ "-s0" set SUBSTREAM=0
if /i "%1" equ "-s1" set SUBSTREAM=1
if /i "%1" equ "-s2" set SUBSTREAM=2
if /i "%1" equ "-mux" set ONLYFFMPEG=1
if /i "%1" equ "-noff" set NOFFMPEG=1
if /i "%1" equ "-ns" set SHRINK=
if /i "%1" equ "-ana" set FIX16=1
if /i "%1" equ "-qs" set PRECSCALE=1
if /i "%1" neq "-q" goto noquant
shift
set QUANT=%1
set ONEPASS=1
:noquant
if /i "%1" neq "-b" goto nobitrate
shift
set BITRATE=%1
set BITRATEISSET=1
:nobitrate
if /i "%1" neq "-l" goto nolog
shift
set LOGFILE=%1
:nolog

shift
goto parseparams
:paramsdone

set AUXSUBPARAMS=-font %WINDIR%\Fonts\arial.ttf -subfont-text-scale 4
if "%SUBSTREAM%"=="" goto subfile
set SUBS=-sid %SUBSTREAM% %AUXSUBPARAMS%
if not '%3'=='' shift /2
goto endsub
:subfile

if '%3'=='' goto twoparams
if not exist %2 goto nosubfile
set SUBS=-sub %2 %AUXSUBPARAMS%
shift /2
goto endsub
:nosubfile
echo Warning: subtitle file %2 not found.
set EXP=
goto endsub
:twoparams

if '%2'=='' goto nosubparam
if not exist %2 goto nosubparam
set SUBS=-sub %2 %AUXSUBPARAMS%
shift /2
goto endsub
:nosubparam
if exist "%~dpn1.smi" set SUBS=-sub "%~dpn1.smi" %AUXSUBPARAMS%
if exist "%~dpn1.sub" set SUBS=-sub "%~dpn1.sub" %AUXSUBPARAMS%
if exist "%~dpn1.srt" set SUBS=-sub "%~dpn1.srt" %AUXSUBPARAMS%
if exist "%~dpn1.ssa" set SUBS=-sub "%~dpn1.ssa" %AUXSUBPARAMS%
:: if not defined SUBS set EXP=
:endsub
if %HEIGHT%==240 goto noexp
if defined SUBS set EXP=-vf-add expand=0:-32:0:0:1::16
:noexp

if not '%1'=='' goto parok
echo Syntax: %~nx0 [switches] ^<input^> [subs] [output-base-name]
echo.
echo Switches:
echo 	-b ^<bitrate^>	Set bitrate (default is 400)
echo 	-ac		Copy source audio stream (default is encode to mp3 ~192kbps)
echo 	-mp3		Encode audio to 128kbps abr mp3
echo 	-aqq		Encode audio with lame preset extreme (~220 kbps)
echo 	-4, -15, -2	Source is 4:3, 15:9 or 2.xx:1 (default is 16:9)
echo 	-ana		Source is 4:3, but actual dimensions must be 16:9
echo 	-ns             Do not shrink video (by default width is reduced by 4%%)
echo 	-qs             Use quality scaling method
echo 	-s0, -s1, -s2	Use embedded subtitle stream with given index
echo 	-l ^<file-name^>	Set log file name
echo 	-mux		Do only FFmpeg step, no reencode
echo 	-t		Test mode (55 seconds of video starting at 8:00)
goto :EOF
:parok

if exist mencoder.exe goto menc
for %%i in (mencoder.exe) do if not "%%~$PATH:i"=="" goto menc
echo Error: mencoder.exe not found.
goto :EOF
:menc

if not defined LOGFILE goto nologs
:logcycle
if not exist %LOGFILE% goto lognp
echo Warning: file %LOGFILE% exists, writing log to 2%LOGFILE%.
set LOGFILE=2%LOGFILE%
goto logcycle
:lognp
set PLF=-passlogfile %LOGFILE%
:nologs

if not "%2"=="" goto foundbasename
set BASENAME=%~n1
goto basenameset
:foundbasename
set BASENAME=%2
:basenameset
set OUTPUT="%BASENAME%-m.avi"
for %%i in (ffmpeg.exe) do if not "%%~$PATH:i"=="" goto ffmpegfound
if not exist ffmpeg.exe goto noffmpeg
if not exist pthreadGC2.dll goto noffmpeg
:ffmpegfound
set FFMPEG="%BASENAME%.d2.avi"
goto ffmpegf
:noffmpeg
echo Warning: no ffmpeg.exe or no pthreadGC2.dll were found.
:ffmpegf

set WIDTH=-2
if defined SHRINK goto shrink
if %HEIGHT%==193 set HEIGHT=192
set CROP=-vf-add crop=320
goto endtrans
:shrink
if not %HEIGHT%==192 goto nofixheight
set HEIGHT=208
:nofixheight
if %HEIGHT%==193 set HEIGHT=192
set CROP=-vf-add crop=%SHRINK%,scale=320:%HEIGHT%::::::1
:endtrans
if not defined EXP set EXP=-vf-add expand=::::::16

set SCALE=-vf-add scale=%WIDTH%:%HEIGHT%
if not defined PRECSCALE goto nopscale
set SCALE=-sws 9 %SCALE%:::10:10:::1
:nopscale
if not defined FIX16 goto nofix16
set SCALE=-vf-add dsize=16/9 %SCALE%
:nofix16

if not defined ONEPASS goto skipquant
if defined BITRATEISSET goto skipquant
set XVIDQUAL=fixed_quant=%QUANT%
goto endquant
:skipquant
set XVIDQUAL=bitrate=%BITRATE%
:endquant
:: if defined TEST set ONEPASS=1

if defined NOENCODE goto test
if not defined ONLYFFMPEG goto noffmpegstep
SET OUTPUT=%1
goto ffmpegstep
:noffmpegstep

if defined ONEPASS goto nopass1
set PASS=pass=2:
set PASSNAME=Pass 2 -
title %BASENAME% - Pass 1 - %D2TITLE%
mencoder %1 -o nul -ovc xvid -xvidencopts pass=1:max_bframes=0 %PLF% -nosound %SUBS% %SCALE% %CROP% %EXP% %TEST% -vf-add harddup
:nopass1
title %BASENAME% - %PASSNAME% %D2TITLE%
mencoder %1 -o %OUTPUT% -ovc xvid -xvidencopts %PASS%%XVIDQUAL%:max_bframes=0 %PLF% -oac %AUDIO% %SUBS% %SCALE% %CROP% %EXP% %TEST% -vf-add harddup
if exist "%LOGFILE%" del %LOGFILE%

:: if defined TEST goto noff
:ffmpegstep
if not defined FFMPEG goto noff
if defined NOFFMPEG goto noff
title FFmpeg pass - %BASENAME% - %D2TITLE%
ffmpeg -i %OUTPUT% -vcodec copy -acodec copy -async 1 %FFMPEG%
del %OUTPUT%
:noff
title %D2TITLE%

goto :EOF
:test
if not defined ONEPASS echo Two-pass encoding
echo mencoder %1 -o %OUTPUT% -ovc xvid -xvidencopts %PASS%%XVIDQUAL%:max_bframes=0 %PLF% -oac %AUDIO% %SUBS% %SCALE% %CROP% %EXP% %TEST%
echo.